/*
  $Id: CreateRTree.cpp 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#include "RTreeUtil.h"

int main(int argc, char *argv[]) 
{
  if (argc<5 || argc>7) {
    cerr<<"Usage: "<<argv[0]<<" input_file output_file no_attr attr_map [node_capacity] [no_rec]."<<endl;
    return -1;
  }

  unsigned no_attr=atoi(argv[3]);
  string attr_map=string(argv[4]);

  unsigned index_cap=10;
  unsigned no_rec=0;
  if (argc>5) {
    index_cap=atoi(argv[5]);
    if (argc==7) {
      no_rec=atoi(argv[6]);
    }
  }
  
  RTree::RTree *rtree=0;
  IStorageManager *storagemngr=0;
  StorageManager::IBuffer *file=0;

  createRTree(argv[1], argv[2], rtree, storagemngr, file, index_cap, no_attr, attr_map, no_rec);

  if (rtree!=0) delete rtree;
  if (file!=0) delete file;
  if (storagemngr!=0) delete storagemngr;
}



