/*
  $Id: DataCont.cpp 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#include "DataCont.h"

#include <iterator>

// --- operator<<

ostream& operator<<(ostream& out, VectPairPoint& vect)
{
  for (VectPairPointIt it=vect.begin(); it!=vect.end(); it++) out<<*it<<"\n";
  return out;
}

ostream& operator<<(ostream& out, VectPoint& vect)
{
  for (VectPointIt it=vect.begin(); it!=vect.end(); it++) out<<*it<<"\n";
  return out;
}

ostream& operator<<(ostream& out, VectRegID& vect)
{
  for (VectRegIDIt it=vect.begin(); it!=vect.end(); it++) out<<*it<<"\n";
  return out;
}

ostream& operator<<(ostream& out, const TopK& topk)
{
  out<<"size\t"<<topk.size();
  if (!topk.empty()) out<<"\ttop\t"<<topk.top();
  return out;
}
