/*
  $Id: RTreeUtil.h 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#ifndef __RTreeUtil__
#define __RTreeUtil__

#include <string>

using namespace std;

#include <spatialindex/SpatialIndexImpl.h>
#include <rtree/RTree.h>

void createRTree(string input_file,
		 string output_file,
		 RTree::RTree*& rtree,
		 IStorageManager*& storagemngr,
		 StorageManager::IBuffer*& file,
		 unsigned index_capacity,
		 unsigned no_attr,
		 string attr_map,
		 unsigned no_rec=0);
void loadRTree(string input_file,
	       RTree::RTree*& rtree, 
	       IStorageManager*& storagemngr, 
	       StorageManager::IBuffer*& file);

ostream& operator<<(ostream& out, const INode& node);

class OutputReadableQueryStrategy: public SpatialIndex::IQueryStrategy
{
private:
  queue<long> ids;
public:
  void getNextEntry(const IEntry& entry, long& nextEntry, bool& hasNext);
};

class OutputGnuplotQueryStrategy: public SpatialIndex::IQueryStrategy
{
private:
  queue<long> ids;
public:
  void getNextEntry(const IEntry& entry, long& nextEntry, bool& hasNext);
};

#endif
