/*
  $Id: ReadDataset.h 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#ifndef _ReadDataset_
#define _ReadDataset_

#include <cstdlib>
#include <fstream>
#include <iostream>
#include <iterator>
#include <vector>

using namespace std;

template <class Tuple> 
void readDataset (vector<Tuple> &vect, const string file_name, const unsigned size = 0)
{
  ifstream file(file_name.c_str());
  if (!file) 
    {
      cerr << "can't open input file \"" << file_name << "\"" << endl;
      exit(EXIT_FAILURE);
    }
  cerr << "reading input file \"" << file_name.substr(file_name.rfind('/') + 1) << "\"..."; cerr.flush();
  if (size == 0) 
    {
      copy(istream_iterator<Tuple>(file), istream_iterator<Tuple>(), back_inserter(vect));
    }
  else
    {
      for (unsigned crt_size = 0; crt_size < size; crt_size++) 
	{
	  Tuple tuple;
	  file >> tuple;
	  vect.push_back(tuple);
	}
    }
  cerr << " done (" << vect.size() << " entries, " << vect.size() * sizeof(vect) / 1024 << " Kb)" << endl;
  file.close();
}

#endif
